import React, { PropTypes } from 'react';

import { dropdownOptionsShape } from './utils/propTypes';


export default ({
    block,
    displayName,
    Dropdown
}) => {

    return React.createClass({

        displayName,

        propTypes: {
            disabled: PropTypes.bool,
            expanded: PropTypes.bool,
            onExpand: PropTypes.func,
            options: dropdownOptionsShape
        },

        getDefaultProps() {
            return {
                disabled: false,
                expanded: false,
                onExpand: () => {},
                options: []
            };
        },

        onClick() {
            if (this.props.disabled) {
                return;
            }

            this.props.onExpand();
        },

        render() {
            const { expanded, options } = this.props;

            if (!expanded) {
                const disabled = this.props.disabled || options.length === 0;
                return (
                    <div
                        className={ block({ enabled: !disabled, disabled }) }
                        onClick={ this.onClick }>
                        <i className={ block('icon') } />
                    </div>
                );
            }

            return (
                <Dropdown { ...this.props } />
            );
        }

    });

};
