export default (value, options, components, getComponentHeight) => {
    const filteredOptions = options.filter((option) => value === option.value);
    if (filteredOptions.length === 0) {
        return components.options.scrollTop;
    }

    const option = filteredOptions[0];
    const index = options.indexOf(option);
    const component = components[index];

    if (component) {
        const height = options.slice(0, index)
            .map((option) => {
                const i = options.indexOf(option);
                return getComponentHeight(i);
            })
            .reduce((prev, curr) => {
                return prev + curr;
            }, 0);

        return height - (components.options.clientHeight / 2) + (getComponentHeight(index) / 2);
    }

    return components.options.scrollTop;
};
