import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';

import isNullOrEmpty from '../../isNullOrEmpty';


export default ({
    block,
    displayName
}) => {

    invariant(block !== undefined, 'Missing purebem block');
    invariant(!isNullOrEmpty(displayName), 'Missing display name.');

    return React.createClass({

        displayName,

        mixins: [PureRenderMixin],

        propTypes: {
            children: PropTypes.node,
            html: PropTypes.bool,
            multiline: PropTypes.bool,
            text: PropTypes.node
        },

        getDefaultProps() {
            return {
                children: null,
                html: false,
                multiline: false,
                text: '&nbsp;'
            };
        },

        renderText() {
            const { html, text } = this.props;
            const className = block('text');

            return html
                ? (<span className={ className } dangerouslySetInnerHTML={ { __html: text } } />)
                : (<span className={ className }>{ text }</span>);
        },

        render() {
            const { multiline, children } = this.props;
            return (
                <label className={ block({ multiline }) }>
                    { this.renderText() }
                    { children }
                </label>
            );
        }

    });

};
