import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import purebem from 'purebem';

import './FoundationControlsLayout.less';


const block = purebem.of('foundation-controls-layout');

const FoundationControlsLayout = React.createClass({

    mixins: [PureRenderMixin],

    childContextTypes: {
        column: PropTypes.arrayOf(PropTypes.oneOf(['mobile-column', 'mobile-row', 'tablet-row', 'desktop-row']))
    },

    propTypes: {
        children: PropTypes.node,
        column: PropTypes.oneOf(['mobile', 'tablet', 'desktop'])
    },

    getDefaultProps() {
        return {
            children: null,
            column: null
        };
    },

    getChildContext() {
        return {
            column: this.getColumns()
        };
    },

    getColumns() {
        const { column } = this.props;

        switch (column) {
            case 'mobile':
                return ['mobile-column', 'tablet-row'];

            case 'tablet':
                return ['mobile-column', 'desktop-row'];

            case 'desktop':
                return ['mobile-column'];

            default:
                return ['mobile-row'];
        }
    },

    render() {
        const { children } = this.props;
        return (
            <div className={ block(this.getColumns()) }>
                { children }
            </div>
        );
    }

});

export default FoundationControlsLayout;
