import findindex from 'lodash.findindex';


export const type = '@@billogram-foundation/MESSAGE.HIDE';

export const hide = ({ timeoutId, timestamp }) => {
    return {
        type,
        payload: {
            timeoutId,
            timestamp
        }
    };
};

export default ({ timeoutId, timestamp }) => {
    return (dispatch) => {
        clearTimeout(timeoutId);
        dispatch(hide({ timeoutId, timestamp }));
    };
};

export const reducer = {
    [type]: (state, action) => {
        const { entries } = state;
        const { timestamp } = action.payload;
        const index = findindex(entries, (entry) => entry.timestamp === timestamp);

        if (index === -1) {
            return state;
        }

        return {
            ...state,
            entries: [
                ...entries.slice(0, index),
                ...entries.slice(index + 1)
            ]
        };
    }
};
